/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package newsAnalyzer;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author rcastari
 */
public abstract class PropertiesLoader {

    protected Properties properties = null;
    
    protected PropertiesLoader(String propertiesFilePath) {
        if (properties == null) {
            Properties p = new Properties();
            FileInputStream in = null;
            try {
                in = new FileInputStream(propertiesFilePath);
                p.load(in);
            } catch (FileNotFoundException ex) {
                Logger.getLogger(PropertiesLoader.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(PropertiesLoader.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    if (in != null) {
                        in.close();
                    }
                } catch (IOException ex) {
                    Logger.getLogger(PropertiesLoader.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            properties = p;
        }
    }

    public String getProperty(String key){
        return properties.getProperty(key);
    }

}
