/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package newsAnalyzer.analyzer.utils;

import newsAnalyzer.analyzer.utils.frontEnds.wordNet.WordNetFrontEnd;
import newsAnalyzer.analyzer.utils.frontEnds.dbpedia.DBpediaFrontEnd;
import java.util.logging.Level;
import java.util.logging.Logger;
import newsAnalyzer.dataModel.Facet;

/**
 *
 * @author rcastari
 */
public class FacetPredictor {

    public static Facet suggest(String tagName) throws Exception {
        Facet facet = WordNetFrontEnd.getInstance().suggestFacet(tagName);
        if(facet == null){
            facet = DBpediaFrontEnd.getInstance().suggestFacet(tagName);
            if(facet == null){
                facet = Facet.DESCRIPTIVE_SUBJECT;
            }
        }
        return facet;
    }

    public static void main (String args[]){
        try {
            System.out.println("Facets suggested:");
            System.out.println("\tFacet suggested for 'Socrates': "+suggest("Socrates"));
            System.out.println("\tFacet suggested for 'New York': "+suggest("New York"));
            System.out.println("\tFacet suggested for 'Middle age': "+suggest("Middle age"));
            System.out.println("\tFacet suggested for 'United Nations': "+suggest("United Nations"));
            System.out.println("\tFacet suggested for 'Apple': "+suggest("Apple"));
            System.out.println("\tFacet suggested for 'World': "+suggest("World"));

        } catch (Exception ex) {
            Logger.getLogger(FacetPredictor.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
