/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package newsAnalyzer.analyzer.utils;

import newsAnalyzer.analyzer.utils.frontEnds.wordNet.WordNetFrontEnd;
import newsAnalyzer.analyzer.utils.frontEnds.wikipedia.WikipediaEntry;
import newsAnalyzer.analyzer.utils.frontEnds.wikipedia.WikipediaFrontEnd;
import java.util.logging.Level;
import java.util.logging.Logger;
import newsAnalyzer.dataModel.NormalizedTag;
import newsAnalyzer.dataModel.TagDraft;

/**
 *
 * @author rcastari
 */
public class TagNormalizer {

    public static NormalizedTag normalize(TagDraft td) throws Exception {

        NormalizedTag nt = null;
        
        String result = null;

//        if (td.getCathegory() == null) {

            WikipediaEntry wikipediaResult = WikipediaFrontEnd.search(td.getName());
            String wordNetResult = WordNetFrontEnd.getInstance().searchNoun(td.getName());

            if (wikipediaResult != null) {
                if (wordNetResult != null) {
                    if (StringComparator.score(wikipediaResult.getName(), td.getName()) > StringComparator.score(wordNetResult, td.getName())) {
                        result = wikipediaResult.getName();
                    } else {
                        result = wordNetResult;
                    }
                } else {
                    result = wikipediaResult.getName();
                }
            } else if (wordNetResult != null) {
                result = wordNetResult;
            }
/*
        } else {
            WikipediaEntry wikipediaResult = WikipediaFrontEnd.search(td.getName(), td.getCathegory().getName());
            if (wikipediaResult != null) {
                result = wikipediaResult.getName();
            }
        }
*/
        if (result != null) {
            nt = new NormalizedTag();
            nt.setName(result);
            nt.setFacet(FacetPredictor.suggest(nt.getName()));
        }

        return nt;
    }


    public static void main(String args[]) {
        try {
            TagDraft td = new TagDraft();
            td.setName("world");
            NormalizedTag nt = normalize(td);
            System.out.println(nt.toString());

        } catch (Exception ex) {
            Logger.getLogger(TagNormalizer.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
 
}
