/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package newsAnalyzer.analyzer.utils.frontEnds.wordNet;

import java.util.HashMap;
import java.util.Iterator;
import java.util.TreeMap;

/**
 *
 * @author rcastari
 */
public class InheritedHypernymsTree {
    private class InheritedHypernym {
        public String name = null;
        public InheritedHypernym parent;
        public HashMap<String,InheritedHypernym> sons = new HashMap<String, InheritedHypernym>();
        public InheritedHypernym(String pname){name=pname;}
        public InheritedHypernym(String pname, InheritedHypernym pparent){name=pname;parent=pparent;}
        public int getLevel(){
            int level;
            if(parent!=null){
                level = parent.getLevel()+1;
            }else{
                level = 0;
            }
            return level;
        }
        public boolean isItOrAntecesor(String node){
            boolean result = name.equals(node);
            if(result==false){
                if(parent==null){
                    result = false;
                }else{
                    result = parent.isItOrAntecesor(node);
                }
            }
            return result;
        }

        @Override
        public String toString(){
            String result = "";
            int level = getLevel();
            for(int i=0; i<level; i++){
                result+=" ";
            }
            result+=name+System.getProperty("line.separator");
            Iterator<InheritedHypernym> ihi = sons.values().iterator();
            while(ihi.hasNext()){
                result+=ihi.next().toString();
            }
            return result;
        }
    }

    TreeMap<Integer,HashMap<String,String>> hypernymsSortedByLevel = new TreeMap<Integer,HashMap<String,String>>();
    HashMap<String,Integer> hypernymsWithLevelArray = new HashMap<String,Integer>();
    HashMap<String,InheritedHypernym> hypernymsMap = new HashMap<String,InheritedHypernym>();
    InheritedHypernym root = null;

    public int add(String hypernymName, String parentName) {

        int result = -1;

        if(root==null && parentName!=null){
            throw new UnsupportedOperationException("The first element must be a root element");
        }else if(root!=null && parentName == null){
            throw new UnsupportedOperationException("Root node cannot be changed");
        }

        InheritedHypernym parentIH = hypernymsMap.get(parentName);

        InheritedHypernym ih = hypernymsMap.get(hypernymName);

        Integer previousLevel = null;

        if(ih==null){

            ih = new InheritedHypernym(hypernymName,parentIH);

            if(parentName==null){
                root=ih;
            }

            if(parentIH!=null){
                parentIH.sons.put(hypernymName, ih);
            }

            hypernymsMap.put(hypernymName, ih);

            int level = ih.getLevel();

            hypernymsWithLevelArray.put(hypernymName, level);

            if (hypernymsSortedByLevel.get(level) == null) {
                hypernymsSortedByLevel.put(level, new HashMap<String, String>());
            }

            hypernymsSortedByLevel.get(level).put(hypernymName, hypernymName);

            result = 1;

        }else{

            if(ih.parent!=null){

                //Comprovar que no es deslligui el pare i que no es produeixi un cicle
                if(!parentIH.isItOrAntecesor(hypernymName)){

                    previousLevel = ih.getLevel();

                    ih.parent.sons.remove(hypernymName);

                    ih.parent = parentIH;

                    parentIH.sons.put(hypernymName, ih);

                    int level = ih.getLevel();

                    hypernymsWithLevelArray.put(hypernymName, level);

                    if (hypernymsSortedByLevel.get(level) == null) {
                        hypernymsSortedByLevel.put(level, new HashMap<String, String>());
                    }

                    if (previousLevel != null) {
                        hypernymsSortedByLevel.get(previousLevel).remove(hypernymName);
                    }

                    hypernymsSortedByLevel.get(level).put(hypernymName, hypernymName);

                    result = 0;

                }
            }
        }

        return result;

    }

    public HashMap<String,String> getHypernymsAtLevel(int level){
        return hypernymsSortedByLevel.get(level);
    }

    public Integer getHypernymLevel(String hypernymName){
        return hypernymsWithLevelArray.get(hypernymName);
    }

    public boolean isEmpty(){
        return hypernymsMap.isEmpty();
    }

    public Iterator<Integer> getLevelIterator(){
        return hypernymsSortedByLevel.keySet().iterator();
    }

    @Override
    public String toString(){
        String result="";

        if(root!=null){
            result=root.toString();
        }

        return result;
    }

}
