/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package newsAnalyzer.dataModel.DAOs;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Date;
import newsAnalyzer.dataModel.Article;
import newsAnalyzer.dataModel.ArticleSource;
import newsAnalyzer.dataModel.Author;
import newsAnalyzer.dataModel.NormalizedTag;
import newsAnalyzer.dataModel.TagDraft;

/**
 *
 * @author rcastari
 */
public interface ArticleDAO extends GenericDAO<Article> {

    public void associateAuthor(Article article, Author author) throws SQLException;
    public void associateAuthor(Article article, Author author, Connection conn) throws SQLException;

    public void associateTagDraft(Article a, TagDraft td) throws SQLException;
    public void associateTagDraft(Article a, TagDraft td, Connection conn) throws SQLException;

    public void associateNormalizedTag(Article a, NormalizedTag nt) throws SQLException;
    public void associateNormalizedTag(Article a, NormalizedTag nt, Connection conn) throws SQLException;

    public void setHasBeenAnalyzed(Article a) throws SQLException;
    public void setHasBeenAnalyzed(Article a, Connection conn) throws SQLException;

    public int getArticleCount(Date date, ArticleSource as) throws SQLException;

}
