/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package newsAnalyzer.dataModel.DAOs.MySQL;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import newsAnalyzer.dataModel.ArticleSource;
import newsAnalyzer.dataModel.DAOs.ArticleSourceDAO;
import newsAnalyzer.dataModel.DAOs.searchCriteriaObjects.SearchCriteria;

/**
 *
 * @ArticleSource rcastari
 */
public class MySQLArticleSourceDAO extends MySQLGenericDAO<ArticleSource> implements ArticleSourceDAO {

    //INSERT Parameters

    @Override
    protected boolean returnGeneratedKeys() {
        return true;
    }

    @Override
    protected String getInsertSQLStatement() {
        return "INSERT INTO ArticleSource (ArticleSourceName) VALUES (?)";
    }

    @Override
    protected void fillInsertPreparedStatementPreviousActions(ArticleSource a, Connection conn) throws SQLException {
        //Do nothing
    }
    
    @Override
    protected void fillInsertPreparedStatement(PreparedStatement ps, ArticleSource a) throws SQLException {
        ps.setString(1, a.getName());
    }

    @Override
    protected void executeInsertPreviousActions(ArticleSource a, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected ArticleSource afterInsertActions(ArticleSource a, Connection conn) throws SQLException {
        return a;
    }

    @Override
    protected ArticleSource afterInsertActions(ArticleSource a, int generatedKey, Connection conn) throws SQLException {
        a.setId(generatedKey);
        return a;
    }

    @Override
    protected String getUpdateSQLStatement() {
        return "UPDATE ArticleSource "
                + "SET articleSourceName = ? "
                + "WHERE ArticleSourceId = ?";
    }

    @Override
    protected boolean hasToBeUpdated(ArticleSource new_e, ArticleSource old_e) {
        return false;
    }



    @Override
    protected void fillUpdatePreparedStatementPreviousActions(ArticleSource e, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected void fillUpdatePreparedStatement(PreparedStatement ps, ArticleSource a) throws SQLException {
        int id;
        try{
            id = a.getId();
            ps.setInt(3, id);
        }catch(NullPointerException ex){
            throw new SQLException("Trying to update an ArticleSource without providing its Id");
        }
        if(a.getName()!=null){
            ps.setString(1, a.getName());
        }else{
            throw new SQLException("Trying to update an ArticleSource with a null name");
        }
    }

    @Override
    protected void executeUpdatePreviousActions(ArticleSource e, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected ArticleSource afterUpdateActions(ArticleSource e, Connection conn) throws SQLException {
        return e;
    }

    //SELECT Parameters

    @Override
    protected String getSelectSQLStatement(SearchCriteria<ArticleSource> a) throws SQLException {
        String sql ="SELECT ArticleSourceId, ArticleSourceName FROM ArticleSource WHERE 1=1";
        if (a != null) {
            if (a.getCriteria().getId() != null) {
                sql += " AND ArticleSourceId = ?";
            } else {
                if (a.getCriteria().getName() != null) {
                    sql += " AND ArticleSourceName = ?";

                }
            }
        }
        return sql;
    }

    @Override
    protected void fillSelectPreparedStatementPreviousActions(SearchCriteria<ArticleSource> a, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected void fillSelectPreparedStatement(PreparedStatement ps, SearchCriteria<ArticleSource> a) throws SQLException {
        int n=1;
        if(a.getCriteria().getId()!=null){
            ps.setInt(n, a.getCriteria().getId());
            n++;
        } else {
            if (a.getCriteria().getName() != null) {
                ps.setString(n, a.getCriteria().getName());
                n++;
            }
        }
    }

    @Override
    protected void executeSelectPreviousActions(SearchCriteria<ArticleSource> a, Connection conn) throws SQLException {
        //Do nothing
    }
    
    @Override
    protected List<ArticleSource> afterSelectActions(ResultSet rs, SearchCriteria<ArticleSource> a, Connection conn) throws SQLException {

        List<ArticleSource> list = new ArrayList<ArticleSource>();

        while(rs.next()){

            ArticleSource ArticleSource = new ArticleSource();

            ArticleSource.setId(rs.getInt(1));
            ArticleSource.setName(rs.getString(2));

            list.add(ArticleSource);
        }

        return list;

    }

    @Override
    protected void preLoadActions(ArticleSource e, Connection conn) throws SQLException {
        //Do nothing
    }



}
