/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package newsAnalyzer.dataModel.DAOs.MySQL;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;
import newsAnalyzer.dataModel.DAOs.DAOFactory;
import newsAnalyzer.dataModel.TagDraft;
import newsAnalyzer.dataModel.DAOs.TagDraftDAO;
import newsAnalyzer.dataModel.DAOs.searchCriteriaObjects.SearchCriteria;
import newsAnalyzer.dataModel.DAOs.searchCriteriaObjects.TagDraftCriteria;
import newsAnalyzer.dataModel.Facet;
import newsAnalyzer.dataModel.NormalizedTag;

/**
 *
 * @TagDraft rcastari
 */
public class MySQLTagDraftDAO extends MySQLGenericDAO<TagDraft> implements TagDraftDAO {

    //INSERT Parameters

    @Override
    protected boolean returnGeneratedKeys() {
        return true;
    }

    @Override
    protected String getInsertSQLStatement() {
        return "INSERT INTO TagDraft (TagDraftName, TagDraftCathegoryId, TagDraftFacetId, NormalizedTagId) VALUES (?, ?, ?, ?)";
    }

    @Override
    protected void fillInsertPreparedStatementPreviousActions(TagDraft a, Connection conn) throws SQLException {
        //Do nothing
    }
    
    @Override
    protected void fillInsertPreparedStatement(PreparedStatement ps, TagDraft a) throws SQLException {
        ps.setString(1, a.getName());
        if (a.getCathegory() != null){
            if (a.getCathegory().getId()==null){
                a.setCathegory(load(a.getCathegory(),ps.getConnection()));
            }
            if (a.getCathegory().getId() != null) {
                ps.setInt(2, a.getCathegory().getId());
            } else {
                throw new SQLException("TagDraft Cathegory Id is null for a non empty TagDraft Cathegory");
            }
        }else{
            ps.setNull(2, Types.INTEGER);
        }
        if (a.getFacet() != null) {
            if(a.getFacet()!=Facet.NULL){
                ps.setInt(3, a.getFacet().getId());
            }else{
                ps.setNull(3, Types.INTEGER);
            }
        } else {
            ps.setNull(3, Types.INTEGER);
        }
        if (a.getNormalizedTag() != null) {
            if (a.getNormalizedTag().getId() == null) {
                a.setNormalizedTag(DAOFactory.getDAOFactory().getNormalizedTagDAO().load(a.getNormalizedTag(),ps.getConnection()));
            }
            ps.setInt(4, a.getNormalizedTag().getId());
        } else {
            ps.setNull(4, Types.INTEGER);
        }
    }

    @Override
    protected void executeInsertPreviousActions(TagDraft a, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected TagDraft afterInsertActions(TagDraft a, Connection conn) throws SQLException {
        return a;
    }

    @Override
    protected TagDraft afterInsertActions(TagDraft a, int generatedKey, Connection conn) throws SQLException {
        a.setId(generatedKey);
        return a;
    }

    @Override
    protected String getUpdateSQLStatement() {
        return "UPDATE TagDraft "
                + "SET TagDraftName = ?, TagDraftCathegoryId = ?, TagDraftFacetId = ?, NormalizedTagId = ? "
                + "WHERE TagDraftId = ?";
    }

    @Override
    protected boolean hasToBeUpdated(TagDraft new_e, TagDraft old_e) {
        boolean result = false;
        if(!new_e.getNormalizedTag().equals(old_e.getNormalizedTag())){
            result = true;
        }
        return result;
    }



    @Override
    protected void fillUpdatePreparedStatementPreviousActions(TagDraft e, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected void fillUpdatePreparedStatement(PreparedStatement ps, TagDraft a) throws SQLException {
        int id;
        try{
            id = a.getId();
            ps.setInt(5, id);
        }catch(NullPointerException ex){
            throw new SQLException("Trying to update a TagDraft without providing its Id");
        }
        if(a.getName()!=null){
            ps.setString(1, a.getName());
        }else{
            throw new SQLException("Trying to update a TagDraft with a null name");
        }
        if(a.getCathegory()!=null){
            if(a.getCathegory().getId()==null){
                a.setCathegory(load(a.getCathegory(),ps.getConnection()));
            }
            ps.setInt(2, a.getCathegory().getId());
        }else{
            ps.setNull(2, Types.INTEGER);
        }
        if(a.getFacet()!=null){
            if(a.getFacet()!=Facet.NULL){
                ps.setInt(3, a.getFacet().getId());
            }else{
                ps.setNull(3, Types.INTEGER);
            }
        }else{
            ps.setNull(3, Types.INTEGER);
        }
        if(a.getNormalizedTag()!=null){
            if(a.getNormalizedTag().getId()==null){
                a.setNormalizedTag(DAOFactory.getDAOFactory().getNormalizedTagDAO().load(a.getNormalizedTag(),ps.getConnection()));
            }
            ps.setInt(4, a.getNormalizedTag().getId());
        }else{
            ps.setNull(4, Types.INTEGER);
        }
    }

    @Override
    protected void executeUpdatePreviousActions(TagDraft e, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected TagDraft afterUpdateActions(TagDraft e, Connection conn) throws SQLException {
        return e;
    }

    //SELECT Parameters
    @Override
    protected String getSelectSQLStatement(SearchCriteria<TagDraft> a) throws SQLException {
        String sql = "SELECT TagDraftId, TagDraftName, TagDraftCathegoryId, TagDraftFacetId, NormalizedTagId FROM TagDraft WHERE 1=1";
        if (a != null) {
            if (a.getCriteria() != null) {
                if (a.getCriteria().getId() != null) {
                    sql += " AND TagDraftId = ?";
                } else {
                    if (a.getCriteria().getName() != null) {
                        sql += " AND TagDraftName = ?";
                    }
                    if (a.getCriteria().getCathegory() != null) {
                        if (a.getCriteria().getCathegory().getId() != null) {
                            sql += " AND TagDraftCathegoryId = ?";
                        } else {
                            throw new SQLException("Load Cathegory " + a.getCriteria().getCathegory().getName() + " first!");
                        }
                    } else if (a.getNullDiscriminatorCriteria(TagDraftCriteria.CATHEGORY) == true) {
                        sql += " AND TagDraftCathegoryId IS NULL";
                    }
                    if (a.getCriteria().getFacet() != null) {
                        if(a.getCriteria().getFacet()!=Facet.NULL){
                            sql += " AND TagDraftFacetId = ?";
                        }else if(a.getNullDiscriminatorCriteria(TagDraftCriteria.FACET) == true){
                            sql += " AND TagDraftFacetId IS NULL";
                        }
                    } else if (a.getNullDiscriminatorCriteria(TagDraftCriteria.FACET) == true) {
                        sql += " AND TagDraftFacetId IS NULL";
                    }
                    if (a.getCriteria().getNormalizedTag() != null) {
                        if (a.getCriteria().getNormalizedTag().getId() != null) {
                            sql += " AND NormalizedTagId = ?";
                        }
                    } else if (a.getNullDiscriminatorCriteria(TagDraftCriteria.NORMALIZED_TAG) == true) {
                        sql += " AND NormalizedTagId IS NULL";
                    }
                }
            }
        }
        return sql;
    }

    @Override
    protected void fillSelectPreparedStatementPreviousActions(SearchCriteria<TagDraft> a, Connection conn) throws SQLException {
        //Do nothing
    }

    @Override
    protected void fillSelectPreparedStatement(PreparedStatement ps, SearchCriteria<TagDraft> a) throws SQLException {
        int n = 1;
        if (a != null) {
            if (a.getCriteria() != null) {
                if (a.getCriteria().getId() != null) {
                    ps.setInt(n, a.getCriteria().getId());
                    n++;
                } else {
                    if (a.getCriteria().getName() != null) {
                        ps.setString(n, a.getCriteria().getName());
                        n++;
                    }
                    if (a.getCriteria().getCathegory() != null) {
                        if (a.getCriteria().getCathegory().getId() != null) {
                            ps.setInt(n, a.getCriteria().getCathegory().getId());
                            n++;
                        }
                    }
                    if (a.getCriteria().getFacet() != null) {
                        if(a.getCriteria().getFacet()!=Facet.NULL){
                            ps.setInt(n, a.getCriteria().getFacet().getId());
                            n++;
                        }
                    }
                    if (a.getCriteria().getNormalizedTag() != null) {
                        if (a.getCriteria().getNormalizedTag().getId() != null) {
                            ps.setInt(n, a.getCriteria().getNormalizedTag().getId());
                            n++;
                        }
                    }
                }
            }
        }
    }

    @Override
    protected void executeSelectPreviousActions(SearchCriteria<TagDraft> a, Connection conn) throws SQLException {
        //Do nothing
    }
    
    @Override
    protected List<TagDraft> afterSelectActions(ResultSet rs, SearchCriteria<TagDraft> a, Connection conn) throws SQLException {

        List<TagDraft> list = new ArrayList<TagDraft>();

        while(rs.next()){

            TagDraft td = new TagDraft();

            td.setId(rs.getInt(1));
            td.setName(rs.getString(2));

            int cathegoryId = rs.getInt(3);

            if(!rs.wasNull()){
                TagDraft tdc = new TagDraft();
                tdc.setId(cathegoryId);
                List<TagDraft> tdcList = (new MySQLTagDraftDAO()).find((SearchCriteria<TagDraft>)SearchCriteria.getSearchCriteria(tdc), conn);
                if(tdcList.size()==1){
                    td.setCathegory(tdcList.get(0));
                }else{
                    throw new SQLException("TagDraft Cathegory with id="+cathegoryId+" not found");
                }
            }

            int facetId = rs.getInt(4);

            if(!rs.wasNull()){
                td.setFacet(Facet.getFacet(facetId));
            }

            int ntId = rs.getInt(5);

            if(!rs.wasNull()){
                NormalizedTag nt = new NormalizedTag();
                nt.setId(ntId);
                List<NormalizedTag> ntList = (new MySQLNormalizedTagDAO()).find((SearchCriteria<NormalizedTag>)SearchCriteria.getSearchCriteria(nt), conn);
                if(ntList.size()==1){
                    td.setNormalizedTag(ntList.get(0));
                }else{
                    throw new SQLException("NormalizedTag with id="+cathegoryId+" not found");
                }
            }

            list.add(td);
        }

        return list;

    }

    @Override
    protected SearchCriteria<TagDraft> obtainLoadSearchCriteria(TagDraft td) {
        SearchCriteria<TagDraft> sc = (SearchCriteria<TagDraft>) SearchCriteria.getSearchCriteria(td);
        sc.setNullDiscriminatorCriteria(TagDraftCriteria.NORMALIZED_TAG,false); 
        return sc;
    }

    protected void preLoadActions(TagDraft td, Connection conn) throws SQLException {
        if(td.getCathegory()!=null){
            if(td.getCathegory().getId()==null){
                td.setCathegory(load(td.getCathegory(),conn));
            }
        }
        if(td.getNormalizedTag()!=null){
            if(td.getNormalizedTag().getId()==null){
                td.setNormalizedTag(DAOFactory.getDAOFactory().getNormalizedTagDAO().load(td.getNormalizedTag(), conn));
            }
        }
    }

}
