/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package newsAnalyzer.dataModel.DAOs.searchCriteriaObjects;

import newsAnalyzer.dataModel.Article;
import newsAnalyzer.dataModel.ArticleSource;
import newsAnalyzer.dataModel.Author;
import newsAnalyzer.dataModel.NormalizedTag;
import newsAnalyzer.dataModel.TagDraft;

/**
 *
 * @author rcastari
 */
public abstract class SearchCriteria<E> {

    protected E e = null;

    protected boolean[] searchWithIsNullField;

    public void setNullDiscriminatorCriteria(int field, boolean c){
        if(field >= 0 && field <searchWithIsNullField.length){
            searchWithIsNullField[field] = c;
        }
    }

    public Boolean getNullDiscriminatorCriteria(int field){
        Boolean result = null;

        if(field >= 0 && field <=searchWithIsNullField.length){
            result = searchWithIsNullField[field];
        }

        return result;
    }

    public E getCriteria(){
        return e;
    }

    public void setCriteria(E e){
        this.e = e;
    }

    public static SearchCriteria<?> getSearchCriteria(Object o){

        SearchCriteria<?> sc = null;

        if(o instanceof Article){
            sc = new ArticleCriteria((Article)o);
        }else if(o instanceof ArticleSource){
            sc = new ArticleSourceCriteria((ArticleSource)o);
        }else if(o instanceof Author){
            sc = new AuthorCriteria((Author)o);
        }else if(o instanceof NormalizedTag){
            sc = new NormalizedTagCriteria((NormalizedTag)o);
        }else if(o instanceof TagDraft){
            sc = new TagDraftCriteria((TagDraft)o);
        }

        return sc;
    }

}
