/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package newsAnalyzer.dataModel;

import newsAnalyzer.utils.TextUtils;

/**
 *
 * @author rcastari
 */
public class NormalizedTag extends Tag {

    public NormalizedTag(){
        facet = Facet.NULL;
    }

    @Override
    public Facet getFacet() {
        return facet;
    }

    @Override
    public void setFacet(Facet facet) {
        if(facet==null){
            this.facet = Facet.NULL;
        }
        this.facet = facet;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final NormalizedTag other = (NormalizedTag) obj;

        if(id!=null && other.getId()!=null){
            return other.getId().equals(id);
        }else{
            if(name.equals(other.getName()) && facet == other.getFacet()){
                return true;
            }else{
                return false;
            }
        }
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 41 * hash + (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString(){
        return toString(0);
    }

    @Override
    public String toString(int tabs){
        String result = TextUtils.insertBlanks(tabs) + "Normalized Tag {";
        result += System.getProperty("line.separator");
        result += super.toString(tabs+1);
        result += TextUtils.insertBlanks(tabs) + "}";
        return result;
    }

}
