/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package newsAnalyzer.resultsExplorer.gui.tables;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;
import newsAnalyzer.dataModel.ArticleSource;
import newsAnalyzer.dataModel.statistics.NormalizedTagStatistics;
import newsAnalyzer.resultsExplorer.ResultsExplorerModule;
import newsAnalyzer.retrievers.ArticleRetrieverModule;

/**
 *
 * @author rcastari
 */
public class ResultsPerSourceTableModel extends AbstractTableModel{

    private List<String> columnNames = new ArrayList<String>();
    private List<ArticleSource> sources = new ArrayList<ArticleSource>();
    private List<NormalizedTagStatistics> data = new ArrayList<NormalizedTagStatistics>();
    private ResultsExplorerModule rem = new ResultsExplorerModule();

    public ResultsPerSourceTableModel() throws Exception {
        initialize();
        data = rem.getNTxFontStatistics();
    }

    public ResultsPerSourceTableModel(Date since, Date to) throws Exception {
        initialize();
        data = rem.getNTxFontStatistics(since, to);
    }

    public final void initialize() throws Exception {
        ArticleRetrieverModule arm = new ArticleRetrieverModule();
        columnNames.add("ID");
        columnNames.add("Name");
        columnNames.add("Facet");
        columnNames.add("Global freq.(%)");
        ArticleSource articleSources[] = arm.getArticleSources();
        for (int i = 0; i < articleSources.length; i++) {
            columnNames.add(articleSources[i].getName() + " Freq.(%)");
            sources.add(articleSources[i]);
        }
    }

    public int getRowCount() {
        return data.size();
    }

    public int getColumnCount() {
        return columnNames.size();
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        NormalizedTagStatistics nts2 = data.get(rowIndex);
        Object value = null;
        if (columnIndex < 4) {
            switch (columnIndex) {
                case 0:
                    value = nts2.getId();
                    break;
                case 1:
                    value = nts2.getName();
                    break;
                case 2:
                    value = nts2.getFacet().toString();
                    break;
                case 3:
                    value = 100*nts2.getGlobalCount();
            }
        } else if(columnIndex > 0 && columnIndex < columnNames.size()) {
            value = 100*nts2.getArticlesxSourceCount(sources.get(columnIndex - 4));
        }
        return value;
    }

    @Override
    public String getColumnName(int col) {
        return columnNames.get(col);
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {

        Class c = Float.class;

        switch(columnIndex){
            case 0:
                c = Integer.class;
                break;
            case 1:
            case 2:
                c = String.class;
        }

        return c;
    }



}
