/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package newsAnalyzer.resultsExplorer.gui.tables;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;
import newsAnalyzer.dataModel.TagDraft;
import newsAnalyzer.resultsExplorer.ResultsExplorerModule;

/**
 *
 * @author rcastari
 */
public class ResultsPerTagTableModel extends AbstractTableModel {
    
    private List<TagDraft> tdl = new ArrayList<TagDraft>();
    private List<String> columnNames = new ArrayList<String>();
    private ResultsExplorerModule rem = new ResultsExplorerModule();
    
    public ResultsPerTagTableModel(){
        try {
            tdl = rem.getAllTheTagDrafts();
        } catch (SQLException ex) {
            Logger.getLogger(ResultsPerTagTableModel.class.getName()).log(Level.SEVERE, null, ex);
        }
        columnNames.add("ID");
        columnNames.add("Name");
        columnNames.add("Cathegory ID");
        columnNames.add("Cathegory");
        columnNames.add("Facet");
        columnNames.add("Normalized Tag ID");
        columnNames.add("Normalized Tag");
        columnNames.add("Facet predicted");
    }

    public int getColumnCount() {
        return columnNames.size();
    }

    public int getRowCount() {
        return tdl.size();
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        Object value = null;
        TagDraft td = tdl.get(rowIndex);
        switch (columnIndex) {
            case 0:
                value = td.getId();
                break;
            case 1:
                value = td.getName();
                break;
            case 2:
                value = new ExtendedInteger(td.getCathegory()==null?null:td.getCathegory().getId());
                //value = td.getCathegory()==null?null:td.getCathegory().getId();
                break;
            case 3:
                value = td.getCathegory()==null?"":td.getCathegory().getName();
                break;
            case 4:
                value = td.getFacet()==null?"":td.getFacet().name();
                break;
            case 5:
                value = new ExtendedInteger(td.getNormalizedTag()==null?null:td.getNormalizedTag().getId());
                //value = td.getNormalizedTag()==null?null:td.getNormalizedTag().getId();
                break;
            case 6:
                value = td.getNormalizedTag()==null?"":td.getNormalizedTag().getName();
                break;
            case 7:
                value = td.getNormalizedTag()==null?"":td.getNormalizedTag().getFacet().name();
                break;
            default:
                value = "";
        }
        return value;
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        Class<?> result = String.class;
        switch (columnIndex){
            case 0:
                result = Integer.class;
            case 2:
            case 5:
                result = ExtendedInteger.class;
                break;
            default:
                result = String.class;
        }
        return result;
    }

    private class ExtendedInteger implements Comparable {
        public Integer value;
        public ExtendedInteger(Integer i){
            this.value=i;
        }

        @Override
        public String toString() {
            if(value==null){
                return "";
            }
            return value.toString();
        }

        @Override
        public int hashCode() {
            return value.hashCode();
        }

        @Override
        public boolean equals(Object obj) {
            return value.equals(obj);
        }

        public int compareTo(Object anotherInteger) {
            Integer i = null;
            if(anotherInteger instanceof String){
                if(!((String)anotherInteger).isEmpty()){
                    i = Integer.parseInt((String)anotherInteger);
                }
            }else if(anotherInteger instanceof ExtendedInteger){
                i=((ExtendedInteger)anotherInteger).value;
            }else{
                throw new ClassCastException();
            }
            int result = 0;
            if(i!=null){
                if(value!=null){
                    result = value.compareTo(i);
                }else if(value == null){
                    result = -1;
                }
            }else if(value != null){
                result = 1;
            }
            return result;
        }

    }

    @Override
    public String getColumnName(int column) {
        return columnNames.get(column);
    }

}