/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ArticleRetrieverGUI.java
 *
 * Created on 21/05/2011, 16:59:11
 */

package newsAnalyzer.retrievers.gui;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import newsAnalyzer.NewsAnalyzerProperties;
import newsAnalyzer.dataModel.ArticleSource;
import newsAnalyzer.retrievers.ArticleRetrieverModule;

/**
 *
 * @author rcastari
 */
public class ArticleRetrieverGUI extends javax.swing.JFrame {

    private ArticleRetrieverModule arm = null;
    private DefaultListModel asl = new DefaultListModel();

    private static ArticleRetrieverGUI argui = null;


    public static ArticleRetrieverGUI getInstance(){
        if(argui==null){
            argui = new ArticleRetrieverGUI();
        }
        return argui;
    }

    /** Creates new form ArticleRetrieverGUI */
    private ArticleRetrieverGUI() {
        try {
            arm = new ArticleRetrieverModule();
        } catch (Exception ex) {
            Logger.getLogger(ArticleRetrieverGUI.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(rootPane, ex, "Error", JOptionPane.ERROR_MESSAGE);
            System.exit(-1);
        }

        ArticleSource[] as = arm.getArticleSources();

        for(int i=0; i<as.length; i++){
            asl.addElement(as[i]);
        }
        
        initComponents();

        jFormattedTextField1.setFocusLostBehavior(JFormattedTextField.COMMIT);
        jFormattedTextField2.setFocusLostBehavior(JFormattedTextField.COMMIT);
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel4 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton1 = new javax.swing.JRadioButton();
        jLabel6 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jLabel_dateFormat = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jLabel_status = new javax.swing.JLabel();
        jFormattedTextField1 = new javax.swing.JFormattedTextField();
        jLabel_dateValidator = new javax.swing.JLabel();
        jLabel_listValidator = new javax.swing.JLabel();
        jFormattedTextField2 = new javax.swing.JFormattedTextField();
        jLabel_minutesValidator = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("NewsAnalyzer v0.1");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                windowCloseOperation(evt);
            }
        });

        jLabel4.setText("Automatically retrieve:");

        jLabel1.setText("Retrieve articles since:");

        jLabel2.setFont(new java.awt.Font("Arial", 1, 14));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("Article Retriever Module Setup");

        jLabel5.setText("minutes");
        jLabel5.setVisible(false);

        jList1.setModel(asl);
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jList1);

        buttonGroup1.add(jRadioButton2);
        jRadioButton2.setSelected(true);
        jRadioButton2.setText("No");
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });

        buttonGroup1.add(jRadioButton1);
        jRadioButton1.setText("Yes");
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        jLabel6.setText("Retrieve each:");
        jLabel6.setVisible(false);

        jButton1.setText("Retrieve");
        jButton1.setEnabled(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel3.setText("Select article sources:");

        jLabel_dateFormat.setText("Date format: dd/mm/yyyy");

        jButton2.setText("Stop");
        jButton2.setEnabled(false);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel8.setText("Status:");

        jLabel_status.setText("Stopped");

        jFormattedTextField1.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.DateFormatter()));
        jFormattedTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jFormattedTextField1KeyReleased(evt);
            }
        });

        jLabel_dateValidator.setForeground(new java.awt.Color(255, 0, 0));
        jLabel_dateValidator.setText("Warning: Enter a valid date");

        jLabel_listValidator.setForeground(new java.awt.Color(255, 0, 0));
        jLabel_listValidator.setText("Warning: Select at least one source");

        jFormattedTextField2.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("0"))));
        jFormattedTextField2.setEnabled(false);
        jFormattedTextField2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jFormattedTextField2KeyReleased(evt);
            }
        });
        jFormattedTextField2.setVisible(false);

        jLabel_minutesValidator.setForeground(new java.awt.Color(255, 0, 0));
        jLabel_minutesValidator.setText("Warning: Enter a valid number of minutes");
        jLabel_minutesValidator.setVisible(false);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 547, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel1))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel_dateValidator)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                    .addComponent(jFormattedTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel_dateFormat))
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 245, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel8)
                            .addComponent(jLabel4))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel_listValidator)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jRadioButton1)
                                .addGap(18, 18, 18)
                                .addComponent(jRadioButton2))
                            .addComponent(jLabel_status)
                            .addComponent(jLabel_minutesValidator)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel6)
                                .addGap(18, 18, 18)
                                .addComponent(jFormattedTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel5))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jButton1)
                                .addGap(18, 18, 18)
                                .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(165, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jFormattedTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel_dateFormat))
                .addGap(7, 7, 7)
                .addComponent(jLabel_dateValidator)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(8, 8, 8)
                .addComponent(jLabel_listValidator)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jRadioButton2)
                    .addComponent(jRadioButton1))
                .addGap(14, 14, 14)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jFormattedTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel_minutesValidator)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel_status)
                    .addComponent(jLabel8))
                .addContainerGap(23, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
        if(jRadioButton2.isSelected()){
            jFormattedTextField2.setVisible(false);
            jFormattedTextField2.setEnabled(false);
            jLabel5.setVisible(false);
            jLabel6.setVisible(false);
            jLabel_minutesValidator.setVisible(false);
            jButton1.setEnabled(this.areAllFieldsValid());
        }
}//GEN-LAST:event_jRadioButton2ActionPerformed

    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        if (jRadioButton1.isSelected()) {
            jFormattedTextField2.setVisible(true);
            jFormattedTextField2.setEnabled(true);
            jLabel5.setVisible(true);
            jLabel6.setVisible(true);
            jLabel_minutesValidator.setVisible(true);
            jButton1.setEnabled(this.areAllFieldsValid());
        }
}//GEN-LAST:event_jRadioButton1ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        jButton1.setEnabled(false);
        
        jList1.setEnabled(false);
        jFormattedTextField1.setEnabled(false);
        jFormattedTextField2.setEnabled(false);
        jRadioButton1.setEnabled(false);
        jRadioButton2.setEnabled(false);

        jButton2.setEnabled(true);

        jLabel_status.setText("Retrieving...");
        
        Date date = (Date) jFormattedTextField1.getValue();

        if(NewsAnalyzerProperties.getInstance().debug()){
            System.out.println("Since Date selected: " + (new SimpleDateFormat("dd/MM/yyyy")).format(date));
        }
        
        Object[] asa = jList1.getSelectedValues();
        
        if(NewsAnalyzerProperties.getInstance().debug()){
            System.out.println("Article sources selected:");
        }

        List<ArticleSource> selectedAS = new ArrayList<ArticleSource>();
        for(int i=0; i<asa.length; i++){
            selectedAS.add((ArticleSource)asa[i]);

            if(NewsAnalyzerProperties.getInstance().debug()){
                System.out.println("\t: " + ((ArticleSource)asa[i]).getName());
            }

        }

        if (date != null) {

            if(jRadioButton1.isSelected()){

                try {

                    long updateTime = 60000*Integer.parseInt(jFormattedTextField2.getValue().toString());

                    arm.retrieveSince(date, selectedAS, updateTime);

                } catch (Exception ex) {
                    Logger.getLogger(ArticleRetrieverGUI.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(rootPane, ex, "Error", JOptionPane.ERROR_MESSAGE);
                }
            }else{
                try {
                    arm.setStartInitValues();
                    arm.retrieveSince(date, selectedAS, this);
                } catch (Exception ex) {
                    Logger.getLogger(ArticleRetrieverGUI.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(rootPane, ex, "Error", JOptionPane.ERROR_MESSAGE);
                }

            }

        }

}//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        arm.invokeStop();
        jButton2.setEnabled(false);
        jButton1.setEnabled(true);
        jList1.setEnabled(true);
        jFormattedTextField1.setEnabled(true);
        jRadioButton1.setEnabled(true);
        if(jRadioButton1.isSelected()){
            jFormattedTextField2.setEnabled(true);
        }
        jRadioButton2.setEnabled(true);
        jLabel_status.setText("Stopped");
    }//GEN-LAST:event_jButton2ActionPerformed

    public void stopRetrieving(){
        this.jButton2ActionPerformed(null);
    }

    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        jButton1.setEnabled(this.areAllFieldsValid());
    }//GEN-LAST:event_jList1ValueChanged

    private void jFormattedTextField1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jFormattedTextField1KeyReleased
        if (jFormattedTextField1.getText().length() >= 10) {
            jButton1.setEnabled(this.areAllFieldsValid());
        }
    }//GEN-LAST:event_jFormattedTextField1KeyReleased

    private void jFormattedTextField2KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jFormattedTextField2KeyReleased
        jButton1.setEnabled(this.areAllFieldsValid());
    }//GEN-LAST:event_jFormattedTextField2KeyReleased

    private void windowCloseOperation(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowCloseOperation
        if (arm.isAlive()) {
            arm.invokeEnd();
        }
        argui = null;
    }//GEN-LAST:event_windowCloseOperation

    public boolean areAllFieldsValid() {
        boolean result = false;

        if (jFormattedTextField1.getText() != null && jFormattedTextField1.isEditValid()) {
            if (!jFormattedTextField1.getText().equals("")) {
                try {
                    jFormattedTextField1.commitEdit();
                } catch (ParseException ex) {
                    Logger.getLogger(ArticleRetrieverGUI.class.getName()).log(Level.SEVERE, null, ex);
                }
                Date sinceDate = (Date) jFormattedTextField1.getValue();
                if (sinceDate != null) {
                    if (sinceDate.after(new Date())) {
                        result = false;
                        jLabel_minutesValidator.setText("Warning: Date in the future not allowed");
                    } else {
                        result = true;
                        jLabel_dateValidator.setText("");
                    }
                } else {
                    result = false;
                    jLabel_dateValidator.setText("Warning: Enter a valid date");
                }
            } else {
                result = false;
                jLabel_dateValidator.setText("Warning: Enter a valid date");
            }
        } else {
            result = false;
            jLabel_dateValidator.setText("Warning: Enter a valid date");
        }

        if(jList1.getSelectedValues().length!=0){
            result = result && true;
            jLabel_listValidator.setText("");
        }else{
            result = false;
            jLabel_listValidator.setText("Warning: Select at least one source");
        }

        if (jRadioButton1.isSelected()) {
            if (jFormattedTextField2.getText() != null && jFormattedTextField2.isEditValid()) {
                if (!jFormattedTextField2.getText().equals("")) {
                    try {
                        jFormattedTextField2.commitEdit();
                    } catch (ParseException ex) {
                        Logger.getLogger(ArticleRetrieverGUI.class.getName()).log(Level.SEVERE, null, ex);
                    }

                    if (jFormattedTextField2.getValue() != null) {
                        result = result && true;
                        jLabel_minutesValidator.setText("");
                    } else {
                        result = false;
                        jLabel_minutesValidator.setText("Warning: Enter a valid number of minutes.");
                    }
                } else {
                    result = false;
                    jLabel_minutesValidator.setText("Warning: Enter a valid number of minutes.");
                }
            } else {
                result = false;
                jLabel_minutesValidator.setText("Warning: Enter a valid number of minutes.");
            }

        }else{
            result = result && true;
        }

        return result;
    }

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ArticleRetrieverGUI().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JFormattedTextField jFormattedTextField1;
    private javax.swing.JFormattedTextField jFormattedTextField2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel_dateFormat;
    private javax.swing.JLabel jLabel_dateValidator;
    private javax.swing.JLabel jLabel_listValidator;
    private javax.swing.JLabel jLabel_minutesValidator;
    private javax.swing.JLabel jLabel_status;
    private javax.swing.JList jList1;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

}
